package viptool.base.action;

import java.awt.event.ActionEvent;

import viptool.base.gui.IChildWindow;
import viptool.base.gui.IWindow;

/**
 * An Action that manages a which window it belongs to
 * 
 * 
 */
public abstract class WindowAction<T extends IWindow> extends ExtendedAction

{
	/**
	 * Generated
	 */
	private static final long serialVersionUID = -7797743889595203652L;
	private T window_;

	/**
	 * @return the window that is connected to the action
	 */
	public T getChildWindow() {
		return window_;

	}

	public IWindow getWindow() {
		return window_;
	}

	public void setWindow(T window) {
		window_ = window;
	}

	/**
	 * This Action is empty but not abstract, because most actions which inherit
	 * from this class don`t do anything
	 * 
	 * @param event
	 * @param window
	 */
	protected void actionPerformed(ActionEvent event, T window) {

	}

	// <><><><><><><><><><><><><><><><><><><><><>
	// Overridden methods from javax.swing.AbstractAction
	// <><><><><><><><><><><><><><><><><><><><><>

	@Override
	public void actionPerformed(ActionEvent event) {
		actionPerformed(event, getChildWindow());
	}

	@Override
	public Object clone() throws CloneNotSupportedException {
		WindowAction<T> action = (WindowAction<T>) super.clone();

		// clone the child window map
		action.window_ = window_;
		return action;
	}
}
