package viptool.base.action;

import viptool.base.gui.IChildWindow;
import viptool.base.gui.IWindow;

public class WindowActionPostProcessor<T extends IWindow> implements IActionPostProcessor
{
    private T window_;

    public WindowActionPostProcessor(T window)
    {
        window_ = window;
    }

    public void processAction(ExtendedAction action)
    {
        if(action instanceof WindowAction)
        {
            ((WindowAction) action).setWindow(window_);
        }
    }

    public int hashCode()
    {
        // generate an own hasCode that is equal for all
        // WindowActionPostProcessors with the same window
        return window_.hashCode() + getClass().getName().hashCode();
    }

    public boolean equals(Object object)
    {
        return object.getClass().equals(WindowActionPostProcessor.class)
                && window_ == ((WindowActionPostProcessor) object).window_;
    }

}
