package viptool.base.error;

import viptool.project.IAbstractFile;

public class CannotOpenFileException extends VipToolException
{
    private IAbstractFile file_;
    
    public CannotOpenFileException(IAbstractFile file)
    {
        super();
        file_ = file;
    }

    public CannotOpenFileException(IAbstractFile file, String message, Throwable throwable)
    {
        super(message, throwable);
        file_ = file;
    }

    public CannotOpenFileException(IAbstractFile file, String message)
    {
        super(message);
        file_ = file;
    }

    public CannotOpenFileException(IAbstractFile file, Throwable throwable)
    {
        super(throwable);
        file_ = file;
    }
    
    public IAbstractFile getAbstractFile()
    {
        return file_;
    }   
}
