package viptool.base.error;

import viptool.base.editor.IEditor;

public class EditorException extends VipToolException
{
    private IEditor editor_ = null;

    public EditorException(IEditor editor)
    {
        this(editor, null, null);
    }

    public EditorException(IEditor editor, String message)
    {
        this(editor, message, null);
    }

    public EditorException(IEditor editor, Throwable throwable)
    {
        this(editor, null, throwable);
    }

    public EditorException(IEditor editor, String message, Throwable throwable)
    {
        super(message, throwable);
        editor_ = editor;
    }
    
    public IEditor getEditor()
    {
        return editor_;
    }

}
