package viptool.base.error;

import viptool.base.editor.IEditor;
import viptool.base.io.IFileInterpreter;

public class EditorNotAcceptedException extends EditorException
{
    private IFileInterpreter file_ = null;

    public EditorNotAcceptedException(IFileInterpreter file, IEditor editor)
    {
        this(file, editor, null, null);
    }

    public EditorNotAcceptedException(IFileInterpreter file, IEditor editor,
            String message)
    {
        this(file, editor, message, null);
    }

    public EditorNotAcceptedException(IFileInterpreter file, IEditor editor,
            Throwable throwable)
    {
        this(file, editor, null, throwable);
    }

    public EditorNotAcceptedException(IFileInterpreter file, IEditor editor,
            String message, Throwable throwable)
    {
        super(editor, message, throwable);
        file_ = file;
    }

    public IFileInterpreter getAbstractFile()
    {
        return file_;
    }

}
