package viptool.base.error;

import java.io.File;

public class FileFormatException extends VipToolException
  {
    private File file_;

    public FileFormatException(File file)
      {
        super();
        file_ = file;
      }

    public FileFormatException(File file, String message,
        Throwable throwable)
      {
        super(message, throwable);
        file_ = file;
      }

    public FileFormatException(File file, String message)
      {
        super(message);
        file_ = file;
      }

    public FileFormatException(File file, Throwable throwable)
      {
        super(throwable);
        file_ = file;
      }

    public File getFile()
      {
        return file_;
      }
  }
