package viptool.base.error;

import viptool.base.io.IFileInterpreter;

public class FileInterpreterException extends VipToolException
{
    private IFileInterpreter fileInterpreter_ = null;
    
    public FileInterpreterException(IFileInterpreter fileInterpreter)
    {
        fileInterpreter_ = fileInterpreter;
    }

    public FileInterpreterException(IFileInterpreter fileInterpreter, String message)
    {
        super(message);
        fileInterpreter_ = fileInterpreter;
    }

    public FileInterpreterException(IFileInterpreter fileInterpreter,Throwable throwable)
    {
        super(throwable);
        fileInterpreter_ = fileInterpreter;
    }

    public FileInterpreterException(IFileInterpreter fileInterpreter,String message, Throwable throwable)
    {
        super(message, throwable);
        fileInterpreter_ = fileInterpreter;
    }
    
    public IFileInterpreter getFileInterpreter()
    {
        return fileInterpreter_;
    }

}
