package viptool.base.error;

import viptool.base.io.IFileInterpreterProvider;

public class FileInterpreterProviderException extends VipToolException
{
    private IFileInterpreterProvider provider_ = null;
    
    public FileInterpreterProviderException(IFileInterpreterProvider provider)
    {
        this(provider, null, null);
    }

    public FileInterpreterProviderException(IFileInterpreterProvider provider, String message, Throwable throwable)
    {
        super(message, throwable);
        provider_ = provider;
    }

    public FileInterpreterProviderException(IFileInterpreterProvider provider, String message)
    {
        this(provider, message, null);
    }

    public FileInterpreterProviderException(IFileInterpreterProvider provider, Throwable throwable)
    {
        this(provider, null, throwable);
    }
    
    public IFileInterpreterProvider getAbstractFileProvider()
    {
        return provider_;
    }
    
}
