package viptool.base.error;

import viptool.project.IAbstractFile;

public class FileRenameException extends VipToolException
{
    private IAbstractFile file_;
    private String newName_;
    
    public FileRenameException(IAbstractFile file, String newName)
    {
        super();
        
        file_ = file;
        newName_ =newName; 
    }

    public FileRenameException(IAbstractFile file, String newName, Throwable throwable)
    {
        super(throwable);
        
        file_ = file;
        newName_ =newName; 
    }
    
    public IAbstractFile getAbstractFile()
    {
        return file_;
    }
    
    public String getNewName()
    {
        return newName_;
    }
    
}
