package viptool.base.error;

import java.io.File;

public class UnsupportedFileException extends VipToolException
{
	//the file input stream couldn't open
	public static int FILENOTFOUND = 0;
	//an IOExcepiton occured while reading
	public static int IOEXCEPTION = 1;
	//the format of the class file isn't known
	public static int UNKOWNFORMAT = 2;
	
	private File file_;
	private int errorcode_;
	
	public UnsupportedFileException(File file, Exception ex, int errorcode)
	{
		super(ex);
	    file_ = file;
	    errorcode_ = errorcode;
	}
	
	public UnsupportedFileException(File file, String message, int errorcode)
	{
		super(message);
	    file_ = file;
	    errorcode_ = errorcode;
	}
	
	public File getFile()
	{
		return file_;
	}
	
	public int getErrorcode()
	{
		return errorcode_;
	}
}
