package viptool.base.event;

import javax.swing.event.ListDataEvent;

/**
 * This Class extends ListDataEvent by adding the list data objects to the event.
 */
public class ExtendedListDataEvent extends ListDataEvent{

	Object[] objects_;
	
	public ExtendedListDataEvent(Object source, int id, int index0, int index1, Object[] objects){
		super(source, id, index0, index1);
		objects_ = objects;
	}
	
	/**
	 * This method returns the list data objects which was changed by the event.
	 * 
	 * @return
	 * 		Array of changed objects
	 */
	public Object[] getObjects(){
		return objects_;
	}
}
