package viptool.base.event;

/**
 * Interface for any workbench listener. Workbench listener are notfied about
 * changes in the workbench.
 */
public interface IWorkbenchListener
{
    /**
     * Notifies the listener that the workspace has changed. This means, the
     * current workspace was closed, and a new one was opened.
     * 
     * @param event
     *            an event object containing more information about the
     *            workspace change, such as the new and the old workspace
     */
    public void workspaceChanged(WorkspaceChangeEvent event);
}
