package viptool.base.event;

import java.util.EventObject;

import viptool.base.IWorkbench;

/**
 * This is the base class for all workbench events, that are used to notify
 * workbench listener about changes in the workbench. It provides common
 * functions for workspace events.
 */
public abstract class WorkbenchEvent extends EventObject
{
    // <><><><><><><><><><><><><><><><><><><><><>
    // Constructors
    // <><><><><><><><><><><><><><><><><><><><><>
    /**
     * Constructs a new workbench event object. This object holds the workbench
     * as source.
     * 
     * @param workbench
     *            the workbench that fired the event
     */
    public WorkbenchEvent(IWorkbench workbench)
    {
        super(workbench);
    }

    // <><><><><><><><><><><><><><><><><><><><><>
    // getter methods
    // <><><><><><><><><><><><><><><><><><><><><>
    /**
     * Returns the workbench that fired the event.
     * 
     * @return the workbench that fired the event
     */
    public IWorkbench getWorkbench()
    {
        return (IWorkbench) getSource();
    }

}
