package viptool.base.gui;

import java.awt.Component;

import javax.swing.Icon;

public interface IWindow
{
    /**
     * Gets the component that should be embedded in a tab and represent the
     * window.
     * 
     * @return a reference to a component
     */
    public Component getComponent();

    /**
     * Gets the title of the window. The title is used for set the text of the
     * parent tab.
     * 
     * @return a string representing the windows name
     */
    public String getTitle();

    /**
     * Gets the Icon of this window. If an icon is set, it is displayed in the
     * headed rectangle of the window.
     * 
     * @return an icon, belonging to the "windowhead"
     */
    public Icon getIcon();

}
