package viptool.base.gui.dialog;

/**
 * This is a class for all dialog constants
 */
public class DialogConstants
{
    // <><><><><><><><><><><><><><><><><><><><><>
    // Button IDs
    // <><><><><><><><><><><><><><><><><><><><><>
    /** ID of the OK Button in the Dialog */
    public static final int BUTTON_OK                    = 1;

    /** ID of the CANCEL Button in the Dialog */
    public static final int BUTTON_CANCEL                = 2;

    /** ID of the RETRY Button in the Dialog */
    public static final int BUTTON_RETRY                 = 4;

    /** ID of the IGNORE Button in the Dialog */
    public static final int BUTTON_IGNORE                = 8;

    /** ID of the YES Button in the Dialog */
    public static final int BUTTON_YES                   = 16;

    /** ID of the NO Button in the Dialog */
    public static final int BUTTON_NO                    = 32;

    /** ID of the FINISH Button in the Dialog */
    public static final int BUTTON_FINISH                = 64;

    /** ID of the NEXT Button in the Dialog */
    public static final int BUTTON_NEXT                  = 128;

    /** ID of the NEXT Button in the Dialog */
    public static final int BUTTON_PREVIOUS              = 256;

    // <><><><><><><><><><><><><><><><><><><><><>
    // Button Sets (Various combinations of two or more buttons)
    // <><><><><><><><><><><><><><><><><><><><><>
    /** A Combination of the OK and CANCEL Button */
    public static final int BUTTON_SET_OKCANCEL          = BUTTON_OK
                                                                 | BUTTON_CANCEL;

    /** A Combination of the RETRY, IGNORE and CANCEL Button */
    public static final int BUTTON_SET_RETRYIGNORECANCEL = BUTTON_RETRY
                                                                 | BUTTON_IGNORE
                                                                 | BUTTON_CANCEL;

    /** A Combination of the YES and NO Button */
    public static final int BUTTON_SET_YESNO             = BUTTON_YES
                                                                 | BUTTON_NO;

    /** A Combination of the YES, NO and CANCEL Button */
    public static final int BUTTON_SET_YESNOCANCEL       = BUTTON_YES
                                                                 | BUTTON_NO
                                                                 | BUTTON_CANCEL;

    /** A Combination of the PREVIOUS, NEXT and CANCEL FINISH */
    public static final int BUTTON_SET_WIZARD_NOCANCEL   = BUTTON_PREVIOUS
                                                                 | BUTTON_NEXT
                                                                 | BUTTON_FINISH;

    /** A Combination of the PREVIOUS, NEXT, FINISH and CANCEL Button */
    public static final int BUTTON_SET_WIZARD            = BUTTON_SET_WIZARD_NOCANCEL
                                                                 | BUTTON_CANCEL;

    // <><><><><><><><><><><><><><><><><><><><><>
    // General
    // <><><><><><><><><><><><><><><><><><><><><>
    /** Indicator that the notice has warning level */
    public final static int TYPE_WARNING                 = 1;

    /** Indicator that the notice has error level */
    public final static int TYPE_ERROR                   = 2;

}