package viptool.base.gui.menu;

import java.awt.Component;

import viptool.base.action.ExtendedAction;
import viptool.base.action.IActionFilter;
import viptool.base.action.IActionPostProcessor;
import viptool.base.gui.menu.event.IExtendedMenuListener;

public interface IExtendedMenu
{
    public void setFilter(IActionFilter filter);

    public void setPostProcessor(IActionPostProcessor postProcessor);

    public IActionFilter getFilter();

    public IActionPostProcessor getPostProcessor();

    public ExtendedAction addMenuItem(String id, String container,
            String insertAt, int seek);

    public ExtendedAction removeMenuItem(String id);

    public void addExtendedMenuListener(IExtendedMenuListener listener);

    public void removeExtendedMenuListener(IExtendedMenuListener listener);

    public Component getMenuItem(String id);

}
