package viptool.base.gui.menu.event;

/**
 * The template menu listener is notified about changes in a menu template. If a
 * menu item is added, the menuElementAdded method is called. If a element is
 * removed, the menuElementRemoved method is called. 
 */
public interface IExtendedMenuListener
{
    /**
     * Called when a menu element was added to the template. The event paremeter
     * contains additional information about the added element.
     * 
     * @param event
     *            an object containing additional information about the event
     */
    public void menuElementAdded(ExtendedMenuEvent event);

    /**
     * Called when a menu element was removed from the template menu. The event
     * parameter contains additional information about the removed element.
     * 
     * @param event
     *            an object containing additional information about the event
     */
    public void menuElementRemoved(ExtendedMenuEvent event);
}
