package viptool.base.gui.selection;

/**
 * A FileTypeFilter decides, if a selection of files is accepted. Additionally
 * to the usual ISelectionFilter, it can consider the type of the selected
 * files.
 */

public interface IFileTypeFilter extends ISelectionFilter {
	public static final int FILETYPE_NORMALFILE = 1;
	public static final int FILETYPE_DIRECTORY = 2;
	public static final int FILETYPE_ALL = 3;

	public static final String ATTR_NAMEPATTERN = "Name";
	public static final String ATTR_CONTENTPROVIDER = "Content";
	public static final String ATTR_FILETYPE = "Type";

	public String getAllowedName();

	public int getAllowedType();

	public String getAllowedContent();
}
