package viptool.base.gui.selection;

/**
 * A SelectionModel represents a set of SelectionFilters.
 */
public interface ISelectionModel
{
    /**
     * Tests whether the given selection is accepted by the selection model. A
     * selection is accepted if and only if every selection filter will accept
     * the selection. If one filter denies the given selection, this method will
     * return false.
     * 
     * @param selection
     *            the selection to test
     * @return true if the selection is accepted and false otherwise
     */
    public boolean isSelectionAccepted(ISelection selection);

    public void addSelectionFilter(ISelectionFilter selectionFilter);

    public void removeSelectionFilter(ISelectionFilter selectionFilter);
}
