package viptool.base.gui.toolbar.event;


/**
 * The extended toolbar listener is notified about changes in a toolbar
 * template. If a toolbar item is added, the toolbarElementAdded method is
 * called. If a element is removed, the toolbarElementRemoved method is called.
 */
public interface IExtendedToolBarListener
  {
    /**
     * Called when a toolbar element was added to the template. The event
     * paremeter contains additional information about the added element.
     * 
     * @param event
     *          an object containing additional information about the event
     */
    public void toolBarElementAdded(ExtendedToolBarEvent event);

    /**
     * Called when a toolbar element was removed from the template toolbar. The
     * event parameter contains additional information about the removed
     * element.
     * 
     * @param event
     *          an object containing additional information about the event
     */
    public void toolBarElementRemoved(ExtendedToolBarEvent event);
  }
