package viptool.console;

import java.awt.Color;
import viptool.base.gui.IView;

/**
 * Interface for all types of consoles. So it is possible to display text in 
 * your console with different colors.
 */
public interface IConsole extends IView {

	/**
	 * Set the color for default messages.
	 * 
	 * @param htmlColor
	 * 		the new color
	 */
	public void setDefaultColor(Color color);
	
    /**
     * Set the color for debug messages.
     * 
     * @param htmlColor
     *      the new color
     */
    public void setDebugColor(Color color);
    
	/**
	 * Set the color for info messages.
	 * 
	 * @param htmlColor
	 * 		the new color
	 */
	public void setInfoColor(Color color);
	
	/**
	 * Set the color for warning messages.
	 * 
	 * @param htmlColor
	 * 		the new Color
	 */
	public void setWarningColor(Color color);
	
	/**
	 * Set the color for error messages.
	 * 
	 * @param htmlColor
	 * 		the new Color
	 */
	public void setErrorColor(Color color);
	
	/**
	 * Append the text to the text that is already diplayed in your console.
	 * The color of the text depends on the level of the message.
	 * 
	 * @param text
	 * 		the text, that should br displayed
	 * @param level
	 * 		the level of the text, that should be displayed
	 */
	public void appendText(String text, int level);
	
}
