package viptool.filesystem.event;

import java.util.EventObject;

import viptool.filesystem.FileSystemEntry;
import viptool.filesystem.IFileSystem;

public class FileSystemEvent extends EventObject
{
    private FileSystemEntry file_;
    private FileSystemEntry folder_;
    
    public FileSystemEvent(IFileSystem fileSystem, FileSystemEntry folder, FileSystemEntry file)
    {
        super(fileSystem);
        
        folder_ = folder;
        file_ = file;
    }
    
    public FileSystemEntry getFile()
    {
        return file_;
    }
    
    public FileSystemEntry getFolder()
    {
        return folder_;
    }
    
    public IFileSystem getFileSystem()
    {
        return (IFileSystem)getSource();
    }
}
