package viptool.impl.base.action.contextmenu;

import java.awt.event.ActionEvent;

import javax.swing.Action;

import viptool.base.action.AbstractFileSelectionAction;
import viptool.base.editor.IEditorProvider;
import viptool.base.error.CannotOpenFileException;
import viptool.base.error.FileInterpreterProviderException;
import viptool.base.io.IFileInterpreterProvider;
import viptool.impl.base.Workbench;
import viptool.project.IAbstractFile;

public class OpenWithAction extends AbstractFileSelectionAction
{
    private IEditorProvider editorProvider_;

    public OpenWithAction(IEditorProvider editorProvider)
    {
        editorProvider_ = editorProvider;

        putValue(Action.NAME, editorProvider.getName());
        putValue(ATTR_ID, "action." + editorProvider.getId());
    }

    public void actionPerformed(ActionEvent event, IAbstractFile selectedFile)
    {
        IFileInterpreterProvider[] providers;

        try
        {
            providers = editorProvider_.getAbstractFileProviders();
            for (int i = 0; i < providers.length; i++)
            {
                if (providers[i].matchFormat(selectedFile))
                {
                    Workbench.getInstance().openFile(selectedFile,
                            providers[i], editorProvider_);
                    return;
                }

            }

            throw new CannotOpenFileException(selectedFile,
                    "No file interpreter found!");
        }
        catch (FileInterpreterProviderException exception)
        {
            Workbench.getInstance().showExceptionInDialog(exception);
        }
        catch (CannotOpenFileException exception)
        {
            Workbench.getInstance().showExceptionInDialog(exception);
        }

    }

}
