package viptool.impl.base.action.file;

import java.awt.event.ActionEvent;

import viptool.base.action.WindowAction;
import viptool.base.editor.IEditor;
import viptool.base.gui.IChildWindow;
import viptool.impl.base.Workbench;

/**
 * This methode closes the child windows it was invoked from. This is typically
 * only one, e.g. if the action is called from a menu or a toolbar.<br>
 * If it is invoked by a context menu more than one child window may be assigned
 * and every one is closed.
 */
public class CloseChildWindowAction extends WindowAction<IChildWindow>
{
    /**
     * This methode is called if the action is performed.
     */
    public void actionPerformed(ActionEvent e, IChildWindow window)
    {
        if (window instanceof IEditor)
        {
            IEditor editor = (IEditor) window;
            Workbench.getInstance().closeEditor(editor, false);
        }
        else
        {
            Workbench.getInstance().closeWindow(window, false);
        }
    }
}
