package viptool.impl.base.action.file;

import java.awt.event.ActionEvent;
import java.io.File;

import viptool.base.action.WindowAction;
import viptool.base.error.FileInterpreterProviderException;
import viptool.base.io.IFileInterpreterProvider;
import viptool.impl.base.Workbench;
import viptool.impl.base.gui.dialog.FileChooserDialog;
import viptool.impl.project.io.ProjectFile;
import viptool.impl.project.io.ProjectFileProvider;
import viptool.project.FileSystem;
import viptool.project.IAbstractFile;

/**
 * This action show an filechooser to select a project-file and adds/loads the
 * selected project into the workspace.
 */
public class LoadProjectAction extends WindowAction
{

    /**
     * This methode is called if the actionis performed.
     */
    public void actionPerformed(ActionEvent e)
    {
        IFileInterpreterProvider provider = new ProjectFileProvider();
        FileChooserDialog chooser = new FileChooserDialog(
                new IFileInterpreterProvider[]
                { provider });
        File file = chooser.getSelectedFile();

        if (file != null)
        {
            IAbstractFile abstractFile = FileSystem.getInstance().createAbstractFile(
                    file);

            try
            {
                if (provider.matchFormat(abstractFile))
                {
                    ProjectFile project = (ProjectFile) provider.createFromFile(abstractFile);
                    Workbench.getInstance().getCurrentWorkspace().addProject(
                            project);
                }
            }
            catch (FileInterpreterProviderException exception)
            {
                Workbench.getInstance().showExceptionInDialog(exception);
            }
        }
    }
}
