package viptool.impl.base.action.file;

import java.awt.event.ActionEvent;
import java.io.File;

import viptool.base.action.WindowAction;
import viptool.base.error.FileInterpreterProviderException;
import viptool.base.io.IFileInterpreterProvider;
import viptool.impl.base.Workbench;
import viptool.impl.base.gui.dialog.FileChooserDialog;
import viptool.impl.project.io.WorkspaceFile;
import viptool.impl.project.io.WorkspaceFileProvider;
import viptool.project.FileSystem;
import viptool.project.IAbstractFile;

/**
 * This action show an filechooser to select a workspace-file and adds/loads the
 * selected workspace.
 */
public class LoadWorkspaceAction extends WindowAction
{
    /**
     * This methode is called if the action is performed.
     */
    public void actionPerformed(ActionEvent e)
    {
        IFileInterpreterProvider provider = new WorkspaceFileProvider();
        FileChooserDialog chooser = new FileChooserDialog(
                new IFileInterpreterProvider[]
                { provider });
        File file = chooser.getSelectedFile();
        if (file != null)
        {
            IAbstractFile abstractFile = FileSystem.getInstance().createAbstractFile(
                    file);

            try
            {
                if (provider.matchFormat(abstractFile))
                {
                    WorkspaceFile workspace = (WorkspaceFile) provider.createFromFile(abstractFile);
                    Workbench.getInstance().setCurrentWorkspace(workspace);
                }
            }
            catch (FileInterpreterProviderException exception)
            {
                Workbench.getInstance().showExceptionInDialog(exception);
            }
        }
    }

}
