package viptool.impl.base.action.file;

import java.awt.event.ActionEvent;

import viptool.base.action.WindowAction;
import viptool.base.editor.IEditor;
import viptool.base.error.EditorNotOpenedException;
import viptool.base.error.VipToolException;
import viptool.base.gui.IChildWindow;
import viptool.impl.base.Workbench;
import viptool.project.IAbstractFile;

/**
 * This methode saves the active Childwindow. If the ChildWindow is no Editor an
 * Exception will be shown.
 */
public class SaveChildWindowAction extends WindowAction<IEditor>
{
    /**
     * This methode is performed if the action is performed.
     */
    public void actionPerformed(ActionEvent event, IEditor window)
    {

    	IEditor editor = window;
    		try{
    			IAbstractFile file = editor.getFileInterpreter().getAbstractFile();
    			if(!file.isLocked() || file.getFileLocker().equals(editor)){
    				editor.save();
    			}
		    }
		    catch (EditorNotOpenedException exception)
		    {
		        Workbench.getInstance().showExceptionInDialog(exception);
			}
    }
}
