package viptool.impl.base.extendedPane.event;

import java.util.EventListener;

/**
 * Interface that must be implemented by listeners that wants to be notified if
 * the active window of the extended pane has changed.
 */
public interface IExtendedPaneListener extends EventListener
{
    /**
     * The method is called by the ExtendedPane class if the active window (the
     * window that has the focus) changed.
     * 
     * @param event
     *            a reference to the ActiveWindowChangeEvent that stores the a
     *            reference to the new active window
     */
    public void activeWindowChanged(ActiveWindowChangeEvent event);

    public void windowClose(WindowCloseEvent event);
}
