package viptool.impl.base.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JWindow;

import viptool.impl.util.resources.ResourceConstants;
import viptool.impl.util.resources.ResourceLoader;
import viptool.util.GeneralUtils;

public class SplashScreen extends JWindow
{
    private static SplashScreen instance_ = null;

    private SplashScreen()
    {
        JLabel label;

        setSize(new Dimension(400, 247));
        GeneralUtils.centerComponent(this, null);

        label = new JLabel(new ImageIcon(ResourceLoader.getInstance().getImage(
                ResourceConstants.IMAGE_SPLASH_SCREEN)));
        label.setBackground(Color.DARK_GRAY);
        label.setBorder(BorderFactory.createRaisedBevelBorder());

        add(label, BorderLayout.CENTER);

        setVisible(true);
        setAlwaysOnTop(true);
    }

    public static synchronized SplashScreen getInstance()
    {
        if (instance_ == null)
        {
            instance_ = new SplashScreen();
        }

        return instance_;
    }

    public void dispose()
    {
        if (!isDisplayable())
        {
            return;
        }

        try
        {
            Thread.sleep(1500);
            super.dispose();
        }
        catch (InterruptedException exception)
        {

        }
    }
}
