package viptool.impl.base.gui.dialog;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.Image;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.io.IOException;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;

import viptool.base.error.ResourceLocateException;
import viptool.base.gui.dialog.DialogConstants;
import viptool.base.gui.dialog.event.ButtonClickedEvent;
import viptool.base.gui.dialog.event.IStandardDialogListener;
import viptool.impl.base.Workbench;
import viptool.impl.util.resources.ResourceConstants;
import viptool.util.resources.image.ImageConstants;

public class AboutDialog extends JPanel implements IStandardDialogListener,
        MouseListener
{

    private static final String url_ = "http://viptool.ku-eichstaett.de/";

    public static StandardModalDialog getAboutDialog()
    {
        AboutDialog about = new AboutDialog();
        StandardModalDialog dialog = new StandardModalDialog("About Viptool",
                "Viptool Release " + ResourceConstants.VIPTOOL_VERSION, about,
                null, DialogConstants.BUTTON_OK, DialogConstants.BUTTON_OK);
        dialog.addStandardDialogListener(about);
        return dialog;
    }

    public AboutDialog()
    {
        setBackground(Color.WHITE);
        setLayout(new BorderLayout());
        Image image = null;
        try
        {
            image = Workbench.getInstance().getResourceLoader().getImage(
                    ImageConstants.IMAGE_ABOUT);
            JLabel im = new JLabel(new ImageIcon(image));
            add(im, BorderLayout.CENTER);
        }
        catch (ResourceLocateException ex)
        {

        }

        JLabel desc = new JLabel(
                "<HTML><center><h2>Visit our Homepage at <br>http://viptool.ku-eichstaett.de/<br>to get more information and new releases.</h2></center></HTML>");
        desc.addMouseListener(this);
        desc.setCursor(new Cursor(Cursor.HAND_CURSOR));

        JPanel descpan = new JPanel();
        descpan.setLayout(new FlowLayout(FlowLayout.CENTER));
        descpan.setBackground(Color.WHITE);
        descpan.add(desc);

        add(descpan, BorderLayout.SOUTH);

    }

    public void buttonClicked(ButtonClickedEvent event)
    {
        StandardModalDialog dialog = (StandardModalDialog) event.getStandardDialog();
        dialog.setVisible(false);
        dialog.dispose();
    }

    public boolean isLinux()
    {
        return !(System.getProperty("os.name").toLowerCase().contains("windows"));
    }

    public void mouseClicked(MouseEvent e)
    {
        if (e.getClickCount() >= 1 && e.getClickCount() <= 2)
        {
            ProcessBuilder pb = new ProcessBuilder();
            String[] cmdWindows =
            { "cmd", "/C", "start", url_ };
            String[] cmdLinux =
            { "firefox", url_ };
            if (isLinux())
            {
                pb.command(cmdLinux);
            }
            else
            {
                pb.command(cmdWindows);
            }

            try
            {
                pb.start();
            }
            catch (IOException ex)
            {
                // nothing to do
            }

        }
    }

    public void mouseEntered(MouseEvent e)
    {
        // TODO Auto-generated method stub

    }

    public void mouseExited(MouseEvent e)
    {
        // TODO Auto-generated method stub

    }

    public void mousePressed(MouseEvent e)
    {
        // TODO Auto-generated method stub

    }

    public void mouseReleased(MouseEvent e)
    {
        // TODO Auto-generated method stub

    }

}
