package viptool.impl.base.gui.layoutmanager.listlayout;

import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.JLabel;

/**
 * This class adds ListLayoutSelectionSupport to the JLable it can be used
 * for easy lists and is a reference for programmers who want to use the
 * ListLayout.
 */
public class SelectableLable extends JLabel implements MouseListener, ListLayoutSelectionSupport{

	//selection state
	boolean isSelected = false;
	
	/**
	 * This constructor create a new label.
	 * 
	 * @param text
	 * 		text which is shown
	 */
	public SelectableLable(String text){
		super(text);
		addMouseListener(this);
	}
	
	/**
	 * implementation of MouseListener
	 * This method is the first part of a simple selection support example. 
	 */
	public void mouseClicked(MouseEvent e) {
		if(e.getClickCount() == 1){
			if(isSelected){
				setForeground(Color.BLACK);
				isSelected = false;
			}else{
				setForeground(Color.RED);
				isSelected = true;
			}
		}
	}

	/**
	 * not used in this example
	 */
	public void mouseEntered(MouseEvent e) {}

	/**
	 * not used in this example
	 */
	public void mouseExited(MouseEvent e) {}
	
	/**
	 * not used in this example
	 */
	public void mousePressed(MouseEvent e) {}

	/**
	 * not used in this example
	 */
	public void mouseReleased(MouseEvent e) {}

	/**
	 * implementation of the ListLayoutSelectionSupport interface
	 * This method is the second part of the list selection support example.
	 */
	public boolean isSelected() {
		return isSelected;
	}
}
