package viptool.impl.base.gui.selection;

import java.util.ArrayList;
import java.util.Iterator;

import viptool.base.gui.selection.ISelectionFilter;
import viptool.impl.base.Workbench;
import viptool.impl.logger.Logger;
import viptool.project.IAbstractFile;

public class FileClosedFilter implements ISelectionFilter
{
    private int min_;

    private int max_;

    public int getMaximumMatches()
    {
        return max_;
    }

    public int getMinimumMatches()
    {
        return min_;
    }

    public boolean isSeletcionAccepted(ArrayList selection)
    {
        int matchCount;
        Object object;
        Iterator it;

        it = selection.iterator();
        matchCount = 0;
        while (it.hasNext())
        {
            object = it.next();

            if(!(object instanceof IAbstractFile))
            {
                Logger.getInstance().warning("The given selection to "
                        + "FileClosedFilter.isSelectionAccepted is "
                        + "not an IAbstractFileException so the "
                        + "selection is not accepted.");
                return false;
            }

            if(Workbench.getInstance().findEditors((IAbstractFile) object).length == 0)
            {
                matchCount++;
            }
        }

        return matchCount >= getMinimumMatches()
                && matchCount <= getMaximumMatches()
                && matchCount == selection.size();
    }

    public void setMaximumMatches(int maximumMatches)
    {
        max_ = (maximumMatches >= 0) ? maximumMatches : Integer.MAX_VALUE;
    }

    public void setMinimumMatches(int minimumMatches)
    {
        min_ = minimumMatches;
    }

}
