package viptool.impl.base.gui.selection;

import java.util.ArrayList;
import java.util.Iterator;

import viptool.base.gui.selection.ISelection;
import viptool.base.gui.selection.ISelectionFilter;
import viptool.base.gui.selection.ISelectionModel;
import viptool.impl.logger.Logger;

public class SelectionModel implements ISelectionModel
{
    private ArrayList filters_;

    public SelectionModel()
    {
        filters_ = new ArrayList();
    }

    public boolean isSelectionAccepted(ISelection selection)
    {
        Iterator it;
        ISelectionFilter filter;
        ArrayList list = new ArrayList();
        
        list.addAll(selection);
        it = filters_.iterator();
        while (it.hasNext())
        {
            filter = (ISelectionFilter) it.next();
            
            if(!filter.isSeletcionAccepted(list))
            {
                return false;
            }
        }
        
        return true;
    }

    public void addSelectionFilter(ISelectionFilter selectionFilter)
    {
        if(selectionFilter != null)
        {
            filters_.add(selectionFilter);
        }
        else
        {
            Logger.getInstance().warning(
                    "null was given to "
                            + "SelectionModel.addSelectionFilter. "
                            + "The request is ignored.");
        }
    }

    public void removeSelectionFilter(ISelectionFilter selectionFilter)
    {
        filters_.remove(selectionFilter);
    }

}
