package viptool.impl.extension;

import java.io.File;
import java.io.IOException;
import java.util.jar.JarFile;
import java.util.jar.Manifest;

import javax.swing.Icon;

import viptool.base.IWorkbench;
import viptool.base.error.FileInterpreterProviderException;
import viptool.base.io.IFileInterpreter;
import viptool.base.io.IFileInterpreterProvider;
import viptool.base.wizard.IWizard;
import viptool.project.IAbstractFile;

public class ExtensionJarInterpreter implements IFileInterpreterProvider{

	public boolean canCreateNewFile(IWorkbench workbench) {
		return false;
	}

	public IFileInterpreter createFromFile(IAbstractFile file) throws FileInterpreterProviderException {
		return null;
	}

	public IFileInterpreter createNewFile(IAbstractFile file) throws FileInterpreterProviderException {
		return null;
	}

	public String getDescription() {
		return "jar-file which contains a VipTool-Extension";
	}

	public String getFileType() {
		return ".jar including extension";
	}

	public Icon getIcon() {
		return null;
	}

	public IWizard getNewFileWizard() {
		return null;
	}

	public boolean hasNewFileWizard() {
		return false;
	}

	/**
	 * This method returns true if the given file is a java jar file which includes a
	 * VipTool-Extension.
	 */
	public boolean matchFormat(IAbstractFile file) throws FileInterpreterProviderException {
		File f = file.getFile();
		if(f != null && f.getName().endsWith(".jar")){
			JarFile jfile;
			try {
				jfile = new JarFile(f);
				Manifest m = jfile.getManifest();
				if(m != null && m.getMainAttributes().getValue("Extension-Class") != null){
					return true;
				}else{
					return false;
				}
			} catch (IOException e) {
				return false;
			}
		}
		return false;
	}

}
