package viptool.impl.extension.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Image;
import java.util.Vector;

import javax.swing.BoxLayout;
import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import viptool.base.wizard.IWizardPage;
import viptool.extension.IExtensionInfo;
import viptool.impl.base.gui.list.ChangeableList;

public class MultiExtensionsPage implements IWizardPage{

	Vector<IExtensionInfo> extensions_ = null;
	ChangeableList list_;
	JCheckBox autoload_;
	JCheckBox load_;
	
	public MultiExtensionsPage(Vector<IExtensionInfo> extensions){
		extensions_ = extensions;
	}
	
	public boolean canGoToPrevoius() {
		return true;
	}

	public JComponent getContent() {
		JPanel panel = new JPanel();
		panel.setBackground(Color.WHITE);
		panel.setLayout(new BorderLayout());
		
		list_ = ChangeableList.generateList(extensions_, true);
		
		panel.add(list_, BorderLayout.CENTER);
		
		JPanel options = new JPanel();
		options.setBackground(Color.WHITE);
		options.setLayout(new BoxLayout(options, BoxLayout.Y_AXIS));
		
		JPanel load = new JPanel();
		load.setBackground(Color.WHITE);
		load.setLayout(new FlowLayout(FlowLayout.LEFT));
		load.add(new JLabel("load added extensions: "));
		load_ = new JCheckBox();
		load.add(load_);
		options.add(load);
		
		JPanel autoload = new JPanel();
		autoload.setBackground(Color.WHITE);
		autoload.setLayout(new FlowLayout(FlowLayout.LEFT));
		autoload.add(new JLabel("Automatically load added extensions on next startup: "));
		autoload_ = new JCheckBox();
		autoload.add(autoload_);
		options.add(autoload);
		
		panel.add(options, BorderLayout.SOUTH);
		
		
		return panel;
	}

	public Image getImage() {
		return null;
	}

	public String getMainDescription() {
		return "Select Extensions which should be added.";
	}
	
	public Object[] getSelectedExtensions(){
		Object[] selected = list_.getList().getSelectedValues();
		return selected;
	}
	
	public boolean getLoad(){
		return load_.isSelected();
	}
	
	public boolean getAutoload(){
		return autoload_.isSelected();
	}

}
