package viptool.impl.extension.wizard;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Image;

import javax.swing.JCheckBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;

import viptool.base.wizard.IWizardPage;

/**
 * This IWizzardPage is a simple text page. 
 */
class TextPage implements IWizardPage{

	//text of the page
	String text_;
	//title of the page
	String title_;
	//selectable text
	String checktext_;
	//show checkable content
	boolean enablecheck_;
	//checkbox for selectable text
	JCheckBox check_;
	
	/**
	 * This constructor creates a new textpage with the given content.
	 * 
	 * @param title
	 * 		titel of the page
	 * @param text
	 * 		text of the page
	 * @param checktext
	 * 		checkable content of the page
	 * @param enablecheck
	 * 		show checkable content
	 */
	public TextPage(String title, String text, String checktext, boolean enablecheck)
	{
		text_ = text;
		title_ = title;
		checktext_ = checktext;
		enablecheck_ = enablecheck;
	}
	
	public boolean canGoToPrevoius() {
		return true;
	}

	public JComponent getContent() {
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.setBackground(Color.WHITE);
		
		JPanel labelPanel = new JPanel();
		labelPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		labelPanel.setBackground(Color.WHITE);
		JLabel label = new JLabel(text_);
		labelPanel.add(label);
		
		panel.add(labelPanel, BorderLayout.CENTER);
		
		if(enablecheck_)
		{
			JPanel south = new JPanel();
			south.setBackground(Color.WHITE);
			south.setLayout(new FlowLayout(FlowLayout.LEFT));
			check_ = new JCheckBox();
			check_.setBackground(Color.WHITE);
			south.add(check_);
			south.add(new JLabel(checktext_));
			panel.add(south, BorderLayout.SOUTH);
		}
		
		return panel;
	}
	
	/*
	 * This method returns the current check state.
	 */
	public boolean isChecked()
	{
		return check_.isSelected();
	}

	/**
	 * Implementation of the IWizzardPage interface
	 * returns always null because there is no image for this page
	 */
	public Image getImage() {
		return null;
	}

	/**
	 * Implementation of the IWizzardPage interface
	 */
	public String getMainDescription() {
		return title_;
	}
	
}