package viptool.impl.project;

import javax.swing.Icon;

import viptool.base.IWorkbench;
import viptool.base.error.FileInterpreterProviderException;
import viptool.base.io.IFileInterpreter;
import viptool.base.wizard.IWizard;
import viptool.impl.base.Workbench;
import viptool.impl.util.resources.ResourceLoader;
import viptool.project.IAbstractFile;
import viptool.project.IAbstractFolder;
import viptool.project.IAbstractFolderProvider;
import viptool.project.wizard.NewFolderWizard;
import viptool.util.resources.ResourceConstants;

/**
 * This class is a little hack. No better solution is known at the moment.
 * 
 */
public class AbstractFolderProvider implements IAbstractFolderProvider
{

    public IFileInterpreter createFromFile(IAbstractFile file)
            throws FileInterpreterProviderException
    {
        throw new FileInterpreterProviderException(this,
                new UnsupportedOperationException());
    }

    public IFileInterpreter createNewFile(IAbstractFile file)
            throws FileInterpreterProviderException
    {
        if(!(file instanceof IAbstractFolder))
        {
            throw new FileInterpreterProviderException(this,
                    "You can only give folder"
                            + "paths to create a new folder!");
        }

        if(!file.getFile().mkdirs())
        {
            throw new FileInterpreterProviderException(this,
                    "The folder cannot be created. Unknown reason!");
        }

        if(file.getParentFolder() == null)
        {
            file.getProject().updateFiles(false);
        }
        else
        {
            file.getParentFolder().update(false);
        }

        return null;
    }

    public String getDescription()
    {
        return "A folder in the file system";
    }

    public String getFileType()
    {
        return "Folder";
    }

    public Icon getIcon()
    {
        return ResourceLoader.getInstance().getIcon(
                ResourceConstants.ICON_FOLDER);
    }

    public IWizard getNewFileWizard()
    {
        return new NewFolderWizard(Workbench.getInstance(), this);
    }

    public boolean hasNewFileWizard()
    {
        return true;
    }

    public boolean matchFormat(IAbstractFile file)
            throws FileInterpreterProviderException
    {
        return (file instanceof IAbstractFolder);
    }

    public boolean canCreateNewFile(IWorkbench workbench)
    {
        return (workbench.getCurrentWorkspace() != null && workbench
                .getCurrentWorkspace().getProjectIterator().hasNext());
    }

}
