package viptool.impl.project.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.tree.TreePath;

import viptool.base.action.WindowAction;
import viptool.impl.project.ProjectGuiLinker;
import viptool.impl.project.gui.ProjectTreePane;
import viptool.impl.util.resources.ResourceLoader;
import viptool.project.IProjectTreeNode;
import viptool.util.Locale;
import viptool.util.resources.ResourceConstants;

/**
 * This action adds the selected node to the blacklist.
 */
public class AddBlacklistAction extends WindowAction{

	/**
	 * This methode creates a new action.
	 * HINT: use ActionManager to get new actions.
	 */
	public AddBlacklistAction()
	{
		if(ResourceConstants.ICON_BLACKLIST != null){
			putValue(AbstractAction.SMALL_ICON, ResourceLoader.getInstance().getIcon(ResourceConstants.ICON_BLACKLIST));
		}
		if(Locale.ACCELERATOR_KEY_ADD_BLACKLIST != null){
			putValue(AbstractAction.ACCELERATOR_KEY, Locale.ACCELERATOR_KEY_ADD_BLACKLIST);
		}
		if(Locale.MENUITEMNAME_ADD_BLACKLIST != null){
			putValue(AbstractAction.MNEMONIC_KEY, Locale.MNEMONIC_KEY_ADD_BLACKLIST);
		}
		putValue(AbstractAction.SHORT_DESCRIPTION, Locale.SHORT_DESCRIPTION_ADD_BLACKLIS);
		putValue(AbstractAction.LONG_DESCRIPTION, Locale.LONG_DESCRIPTION_ADD_BLACKLIST);
		putValue(AbstractAction.NAME, Locale.MENUITEMNAME_ADD_BLACKLIST);
	}
	
	/**
	 * This methode is performed if the action is performed.
	 */
	public void actionPerformed(ActionEvent e) {
		TreePath path = ProjectTreePane.getInstance().getTree().getSelectionPath();
    	if(path != null)
    	{
    		IProjectTreeNode node = (IProjectTreeNode)path.getLastPathComponent();
    		ProjectGuiLinker.getInstance().addToBlacklist(node);
    	}
	}
}
