package viptool.impl.project.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.tree.TreePath;

import viptool.base.action.WindowAction;
import viptool.impl.project.ProjectGuiLinker;
import viptool.impl.project.gui.ProjectTreePane;
import viptool.impl.util.resources.ResourceLoader;
import viptool.project.IProjectTreeNode;
import viptool.util.Locale;
import viptool.util.resources.ResourceConstants;

public class CloseProjectAction extends WindowAction{

	public CloseProjectAction()
	{
		if(ResourceConstants.ICON_PROJECT != null){
			putValue(AbstractAction.SMALL_ICON, ResourceLoader.getInstance().getIcon(ResourceConstants.ICON_PROJECT));
		}
		if(Locale.ACCELERATOR_KEY_CLOSE_PROJECT != null){
			putValue(AbstractAction.ACCELERATOR_KEY, Locale.ACCELERATOR_KEY_CLOSE_PROJECT);
		}
		if(Locale.MNEMONIC_KEY_CLOSE_PROJECT != null){
			putValue(AbstractAction.MNEMONIC_KEY, Locale.MNEMONIC_KEY_CLOSE_PROJECT);
		}
		putValue(AbstractAction.SHORT_DESCRIPTION, Locale.SHORT_DESCRIPTION_CLOSE_PROJECT);
		putValue(AbstractAction.LONG_DESCRIPTION, Locale.LONG_DESCRIPTION_CLOSE_PROJECT);
		putValue(AbstractAction.NAME, Locale.MENUITEMNAME_CLOSE_PROJECT);
	}
	
	public void actionPerformed(ActionEvent e) {
		TreePath path = ProjectTreePane.getInstance().getTree().getSelectionPath();
    	if(path != null)
    	{
    		IProjectTreeNode node = (IProjectTreeNode)path.getLastPathComponent();
    		ProjectGuiLinker.getInstance().closeProject(node);
    	}
	}
}
