package viptool.impl.project.action;

import java.awt.event.ActionEvent;
import java.io.File;

import javax.swing.AbstractAction;
import javax.swing.JOptionPane;
import javax.swing.tree.TreePath;

import viptool.base.action.WindowAction;
import viptool.impl.base.MainFrame;
import viptool.impl.project.ProjectGuiLinker;
import viptool.impl.project.gui.ProjectTreePane;
import viptool.impl.util.resources.ResourceLoader;
import viptool.project.IProjectTreeNode;
import viptool.util.Locale;
import viptool.util.resources.ResourceConstants;

public class NewFolderAction extends WindowAction{

	public NewFolderAction()
	{
		if(ResourceConstants.ICON_NEW_FOLDER != null){
			putValue(AbstractAction.SMALL_ICON, ResourceLoader.getInstance().getIcon(ResourceConstants.ICON_NEW_FOLDER));
		}
		if(Locale.ACCELERATOR_KEY_NEW_FOLDER != null){
			putValue(AbstractAction.ACCELERATOR_KEY, Locale.ACCELERATOR_KEY_NEW_FOLDER);
		}
		if(Locale.MENUITEMNAME_NEW_FOLDER != null){
			putValue(AbstractAction.MNEMONIC_KEY, Locale.MNEMONIC_KEY_NEW_FOLDER);
		}
		putValue(AbstractAction.SHORT_DESCRIPTION, Locale.SHORT_DESCRIPTION_NEW_FOLDER);
		putValue(AbstractAction.LONG_DESCRIPTION, Locale.LONG_DESCRIPTION_NEW_FOLDER);
		putValue(AbstractAction.NAME, Locale.MENUITEMNAME_NEW_FOLDER);
	}
	
	public void actionPerformed(ActionEvent e) {
		TreePath path = ProjectTreePane.getInstance().getTree().getSelectionPath();
    	if(path != null)
    	{
    		IProjectTreeNode node = (IProjectTreeNode)path.getLastPathComponent();
    				
    		if(!(node.isFolder() || node.isProject()))
    		{
    			node = (IProjectTreeNode)node.getParent();
    		}
    		
			String name = JOptionPane.showInputDialog(
            			MainFrame.getInstance(), 
            			"Enter name for new Folder:", 
            			"new Folder:", 
            			JOptionPane.QUESTION_MESSAGE);
			
            if(name != null && name.length()>0)
            {
            	File newfolder = new File(ProjectGuiLinker.getInstance().getFile(node), name);
            	if(newfolder.mkdir())
    			{
    				ProjectGuiLinker.getInstance().importFile(newfolder, node);
    			}
    		}
    	}
	}
}
