package viptool.impl.project.action;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Iterator;
import java.util.List;

import viptool.base.action.WindowAction;
import viptool.impl.project.ProjectGuiLinker;
import viptool.impl.project.gui.ProjectTreePane;
import viptool.project.IProjectTreeNode;

public class PasteElementAction extends WindowAction{

	public void actionPerformed(ActionEvent event)
	{
		//get system-clipboard to enable copy/paste with other applications
		Clipboard sysClip = Toolkit.getDefaultToolkit().getSystemClipboard();
		Object node = ProjectTreePane.getInstance().getTree().getSelectionPath().getLastPathComponent();
		IProjectTreeNode parent = null;
		if(node instanceof IProjectTreeNode)
		{
			parent = (IProjectTreeNode)node;
			Transferable transferable = sysClip.getContents(null);
			List files = null;
			try
			{
				files = (List)transferable.getTransferData(DataFlavor.javaFileListFlavor);
				Iterator iter = files.iterator();
				while(iter.hasNext())
				{
					File file = (File)iter.next();
					ProjectGuiLinker.getInstance().importFile(file, parent);
				}
			}
			catch(Exception ex)
			{
				System.err.println("ShortcutAction: Sorry, there are no files...");
			}
		}
	}
}
