package viptool.impl.project.action;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;
import java.util.Vector;

/**
 * The Transferable for Drag and Drop/ Copy / Paste / Move
 */
public class ProjectTreeTransferable implements Transferable{

	//file-list
	private Vector files_;
	//text to transfer
	private String text_;
	//true if text was exported
	private boolean wasText_ = false;
	//true if it was an internal transfer
	private static boolean isInternal_ = false;
	
	//<><><><><><><><><><><><><><><><>
	// Constructors
	//<><><><><><><><><><><><><><><><>
	/**
	 * creats a new DnDTreeTransferable
	 */
	public ProjectTreeTransferable(Vector files, String text)
	{
		//create file-list
		files_ = files;
		text_ = text;
		isInternal_ = false;
	}

	//<><><><><><><><><><><><><><><><>
	// implementation of transferable-interface
	//<><><><><><><><><><><><><><><><>
	
	public Object getTransferData(DataFlavor flavor) throws UnsupportedFlavorException, IOException {
		if(flavor.equals(DataFlavor.javaFileListFlavor))
		{
			return files_;
		}
		else if(flavor.equals(DataFlavor.stringFlavor))
		{
			wasText_ = true;
			return text_;
		}
		return null;
	}

	public DataFlavor[] getTransferDataFlavors() {
		return new DataFlavor[]{DataFlavor.javaFileListFlavor, DataFlavor.stringFlavor};
	}

	public boolean isDataFlavorSupported(DataFlavor flavor) {
		if(flavor.equals(DataFlavor.javaFileListFlavor))
		{
			return true;
		}
		else if(flavor.equals(DataFlavor.stringFlavor))
		{
			return true;
		}
		return false;
	}
	
	public boolean wasText()
	{
		return wasText_;
	}
	
	public static void setInternal(boolean internal)
	{
		isInternal_ = internal;
	}
	
	public static boolean getInternal()
	{
		return isInternal_;
	}

}
