package viptool.impl.project.action;

import java.awt.event.ActionEvent;

import javax.swing.JOptionPane;

import viptool.base.action.WindowAction;
import viptool.base.error.FileRenameException;
import viptool.base.error.VipToolException;
import viptool.impl.base.MainFrame;
import viptool.impl.base.Workbench;
import viptool.impl.project.ProjectGuiLinker;
import viptool.impl.project.gui.ProjectTreePane;
import viptool.project.IAbstractFile;
import viptool.project.IProjectTreeNode;

public class RenameElementAction extends WindowAction{

	public void actionPerformed(ActionEvent event)
	{
		IProjectTreeNode node = (IProjectTreeNode)ProjectTreePane.getInstance().getTree().getSelectionPath().getLastPathComponent();
		IAbstractFile file = ProjectGuiLinker.getInstance().getAbstractFile(node);
		
		String newName = JOptionPane.showInputDialog(MainFrame.getInstance(), "Please enter new file name:", "Rename file", JOptionPane.QUESTION_MESSAGE);
		
		if(newName == null || newName.length() == 0){
			return;
		}
		
		
		 String[] parts = file.getName().split("[.]");
         if(newName.split("[.]").length > 1){
         	int answear = JOptionPane.showOptionDialog(null, 
         			"Do you want to change the file extension?", "File extension", 
         			JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE, null, null, null);
         	if(answear != JOptionPane.YES_OPTION){
         		newName += "." + parts[parts.length - 1];
         	}
         }else{
	            if (parts.length > 1)
	            {
	                if (!newName.endsWith(parts[parts.length - 1]))
	                {
	                    if (!newName.endsWith("."))
	                    {
	                        newName += ".";
	                    }
	                    newName += parts[parts.length - 1];
	                }
	            }
         }
		
        try {
			file.setName(newName, Workbench.getInstance());
		} catch (FileRenameException e) {
			Workbench.getInstance().showExceptionInDialog(new VipToolException(e));
		}
	}

}
