package viptool.impl.project.action;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;
import javax.swing.tree.TreePath;

import viptool.base.action.WindowAction;
import viptool.impl.project.ProjectGuiLinker;
import viptool.impl.project.gui.ProjectTreeNode;
import viptool.impl.project.gui.ProjectTreePane;
import viptool.impl.util.resources.ResourceLoader;
import viptool.project.IProjectTreeNode;
import viptool.util.Locale;
import viptool.util.resources.ResourceConstants;

public class UpdateElementAction extends WindowAction{

	public UpdateElementAction()
	{
		if(ResourceConstants.ICON_UPDATE != null){
			putValue(AbstractAction.SMALL_ICON, ResourceLoader.getInstance().getIcon(ResourceConstants.ICON_UPDATE));
		}
		if(Locale.ACCELERATOR_KEY_UPDATE_ELEMENT != null){
			putValue(AbstractAction.ACCELERATOR_KEY, Locale.ACCELERATOR_KEY_UPDATE_ELEMENT);
		}
		if(Locale.MNEMONIC_KEY_UPDATE_ELEMENT != null){
			putValue(AbstractAction.MNEMONIC_KEY, Locale.MNEMONIC_KEY_UPDATE_ELEMENT);
		}
		putValue(AbstractAction.SHORT_DESCRIPTION, Locale.SHORT_DESCRIPTION_UPDATE_ELEMENT);
		putValue(AbstractAction.LONG_DESCRIPTION, Locale.LONG_DESCRIPTION_UPDATE_ELEMENT);
		putValue(AbstractAction.NAME, Locale.MENUITEMNAME_UPDATE_ELEMENT);
	}
	
	public void actionPerformed(ActionEvent e) {
		TreePath path = ProjectTreePane.getInstance().getTree().getSelectionPath();
		if(path != null && ( ((ProjectTreeNode)path.getLastPathComponent()).isProject() || ((ProjectTreeNode)path.getLastPathComponent()).isFolder() ))
		{
			ProjectGuiLinker.getInstance().run((IProjectTreeNode)path.getLastPathComponent());
		}
	}
}
