package viptool.impl.project.event;

import viptool.project.IProject;

/**
 * This is a basic event for workspaces that is invoked when projects are added
 * or removed from the workspace.
 */
public class WorkspaceEvent
{
    // the project that was added or removed
    private IProject project_;

    // <><><><><><><><><><><><><><><><><><><><><>
    // Constructors
    // <><><><><><><><><><><><><><><><><><><><><>
    /**
     * Constructs a new workspace event. The workspace is not stored, because
     * there can always be only one workspace at a time, so the invoking
     * workspace can be get by callin Workspace.getInstance().
     * 
     * @param project
     *            the project that was added or deleted
     */
    public WorkspaceEvent(IProject project)
    {
        project_ = project;
    }

    // <><><><><><><><><><><><><><><><><><><><><>
    // getter methods
    // <><><><><><><><><><><><><><><><><><><><><>
    /**
     * Returns the project associated to this event. This project was added or
     * removed from the workspace.
     * 
     * @return the added or removed project
     */
    public IProject getProject()
    {
        return project_;
    }
}
