package viptool.impl.project.event;


/**
 * This is a basic workspace listener who can be notified if projects are added
 * to the workspace. There is also a method that is called if a project is
 * removed from the workspace.
 */
public interface WorkspaceListener
{
    /**
     * Notifies the listener that the project stored in the workspace event has
     * been added to the workspace.
     * 
     * @param workspaceEvent
     *            an event storing additional information about the workspace
     */
    public void projectAdded(WorkspaceEvent workspaceEvent);

    /**
     * Notifies the listener that the project stored in the workspace event has
     * been removed from the workspace.
     * 
     * @param workspaceEvent
     *            an event storing additional information about the workspace
     */
    public void projectRemoved(WorkspaceEvent workspaceEvent);
}
