package viptool.impl.project.gui;

import java.util.Comparator;

import viptool.project.IProjectTreeNode;

public class DefaultTreeComparator implements Comparator{
	
	public int compare(Object arg0, Object arg1) 
	{
		if(arg0 instanceof IProjectTreeNode && arg1 instanceof IProjectTreeNode)
		{
			IProjectTreeNode node0 = (IProjectTreeNode)arg0;
			IProjectTreeNode node1 = (IProjectTreeNode)arg1;
			
			if(node0.isWorkspace() && node1.isWorkspace())
			{
				return arg0.toString().compareToIgnoreCase(arg1.toString());
			}
			else if (node0.isWorkspace() && !node1.isWorkspace())
			{
				return -1;
			}
			else if(node0.isProject() && node1.isWorkspace())
			{
				return 1;
			}
			else if(node0.isProject() && node1.isProject())
			{
				return arg0.toString().compareToIgnoreCase(arg1.toString());
			}
			else if(node0.isProject() && !(node1.isProject() || node1.isWorkspace()))
			{
				return -1;
			}
			else if(node0.isFolder() && (node1.isProject() || node1.isWorkspace()))
			{
				return 1;
			}
			else if(node0.isFolder() && node1.isFolder())
			{
				return arg0.toString().compareToIgnoreCase(arg1.toString());
			}
			else if(node0.isFolder() && !(node1.isProject() || node1.isWorkspace() || node1.isFolder()))
			{
				return -1;
			}
			else if(!node0.isWorkspace() && !node0.isProject() && !node0.isFolder() && (node1.isWorkspace() || node1.isProject() || node1.isFolder()))
			{
				return 1;
			}
			else
			{
				return arg0.toString().compareToIgnoreCase(arg1.toString());
			}
		}
		else
		{
			return arg0.toString().compareToIgnoreCase(arg1.toString());
		}
	}

}
