package viptool.impl.project.gui.treedialogs;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

import viptool.impl.project.gui.ProjectTreePane;

//THIS IS JUST A TESTCLASS AND SHOULD BE REPLACED AT FINAL VERSION
//TODO: Replace at final version or fit look
public class LookAndFeelPanel extends JDialog implements ActionListener{
	//panel to set look and feel
	private ProjectTreePane treepanel_;
	//installed Look and Feels
	private UIManager.LookAndFeelInfo[] infos_;
	//combobox for Look and Feels
	private JComboBox lookandfeels_;
	
	public LookAndFeelPanel(ProjectTreePane panel, JFrame parent)
	{
		super(parent, true);
		setTitle("select Look and Feel:");
		treepanel_ = panel;
		//ask for all installed Look and Feels
		infos_ = UIManager.getInstalledLookAndFeels();
		//set BorderLayout
		getContentPane().setLayout(new BorderLayout());
		//add Look and Feel Combobox
		addLookAndFeelChooser();
		//panel for buttons
		JPanel buttons = new JPanel();
		buttons.setLayout(new FlowLayout());
		//add button to commit
		JButton button = new JButton("OK");
		button.addActionListener(this);
		button.setActionCommand("ok");
		buttons.add(button);
		//add button to cancel
		button = new JButton("Cancel");
		button.addActionListener(this);
		button.setActionCommand("cancel");
		buttons.add(button);
		//add button-panel
		getContentPane().add(buttons, BorderLayout.SOUTH);
		
		pack();
		setVisible(true);
	}
	
	private void addLookAndFeelChooser()
	{
		//create String-array with look and feel names
		String[] laf = new String[infos_.length];
		for(int i=0; i<laf.length; i++)
		{
			laf[i] = infos_[i].getName();
		}
		//create combobox
		lookandfeels_ = new JComboBox(laf);
		//add combobox to dialog
		getContentPane().add(lookandfeels_, BorderLayout.CENTER);
	}

	public void actionPerformed(ActionEvent e) {
		if(e.getActionCommand().equals("ok"))
		{
			//get selected look and feel
			int laf = lookandfeels_.getSelectedIndex();
			String lookandfeelpath = infos_[laf].getClassName();
			//try to set selected look and feel
			try
			{
				UIManager.setLookAndFeel(lookandfeelpath);
				SwingUtilities.updateComponentTreeUI(treepanel_);
			}
			catch(Exception ex)
			{
				//create syserr message
				System.err.println("Look and Feel not found:");
				ex.printStackTrace();
				//create error messagebox
				JOptionPane.showMessageDialog(
						this,
						"Look and Feel error: \n" + ex.toString(),
						"Error:",
						JOptionPane.ERROR_MESSAGE);
			}
		}
		//close LookAndFeelPanel
		setVisible(false);
		dispose();
	}
	
}
