package viptool.impl.project.gui.treedialogs;

import java.io.File;
import java.util.Iterator;

import javax.swing.JOptionPane;

import viptool.impl.base.MainFrame;
import viptool.impl.base.Workbench;
import viptool.impl.project.io.ProjectFile;
import viptool.project.IAbstractFile;

public class ProjectDeleteDialog{

	public static void showDialog(ProjectFile project){
		
		int key = JOptionPane.showConfirmDialog(MainFrame.getInstance(), "Also delete contents of Project?", "Delete Project", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
				
		switch(key){
			case JOptionPane.YES_OPTION:
				//delete project elements
				Iterator<IAbstractFile> iter = project.getFileIterator();
				while(iter.hasNext()){
					deleteFile(iter.next().getFile());
				}
				//delete project folder and file
				File pfile = project.getAbstractFile().getFile();
				if(!pfile.delete()){
					pfile.deleteOnExit();
				}
				if(!pfile.getParentFile().delete()){
					pfile.getParentFile().deleteOnExit();
				}
			case JOptionPane.NO_OPTION:
				Workbench.getInstance().getCurrentWorkspace().removeProject(project);
			default:
				//operation canceled
		}
	}
	
	private static void deleteFile(File file){
		if(file.exists()){
			if(file.isDirectory()){
				File[] files = file.listFiles();
				for(int i=0; i<files.length; i++){
					deleteFile(files[i]);
				}
			}else{
				if(!file.delete()){
					file.deleteOnExit();
				}
			}
		}
	}

}
