package viptool.impl.text.editor;

import viptool.base.editor.IEditor;
import viptool.base.editor.IEditorProvider;
import viptool.base.error.EditorException;
import viptool.base.io.IFileInterpreter;
import viptool.base.io.IFileInterpreterProvider;
import viptool.impl.text.io.TextFile;
import viptool.impl.text.io.TextFileProvider;

public class TextEditorProvider implements IEditorProvider
{

    public boolean accept(IFileInterpreterProvider fileProvider)
    {
        return (fileProvider instanceof TextFileProvider);
    }

    public IEditor createEditor(IFileInterpreter fileInterpreter)
            throws EditorException
    {
        return new TextEditor(this, (TextFile) fileInterpreter);
    }

    public IFileInterpreterProvider[] getAbstractFileProviders()
    {
        return new IFileInterpreterProvider[]
        { new TextFileProvider() };
    }

    public String getName()
    {
        return "Texteditor";
    }

    public String getId()
    {
        return "viptool.text.editor";
    }
}
