package viptool.impl.text.editor.dnd;

import java.awt.Cursor;
import java.awt.datatransfer.DataFlavor;
import java.awt.dnd.DnDConstants;
import java.awt.dnd.DragSource;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;

import viptool.impl.text.editor.TextEditor;

public class TextDropTargetListener implements DropTargetListener{

	private TextEditor editor_;
	//defaultcursor
	private Cursor cursor_;
	
	public TextDropTargetListener(TextEditor editor)
	{
		editor_ = editor;
		cursor_ = editor.getTextPane().getCursor();
	}
	
	public void dragEnter(DropTargetDragEvent dtde) {
		editor_.getTextPane().setCursor(DragSource.DefaultCopyDrop);
	}

	public void dragExit(DropTargetEvent dte) {
		editor_.getTextPane().setCursor(cursor_);
	}

	public void dragOver(DropTargetDragEvent dtde) {
	}

	public void drop(DropTargetDropEvent dtde) {
		editor_.getTextPane().setCursor(cursor_);
		if(dtde.getTransferable().isDataFlavorSupported(DataFlavor.stringFlavor))
		{
			if(dtde.getDropAction() == DnDConstants.ACTION_MOVE)
			{
				dtde.acceptDrop(DnDConstants.ACTION_MOVE);
			}
			else
			{
				dtde.acceptDrop(DnDConstants.ACTION_COPY);
			}
			
			try
			{
				String text = (String)dtde.getTransferable().getTransferData(DataFlavor.stringFlavor);
				editor_.getTextPane().getDocument().insertString(
						editor_.getTextPane().getCaretPosition(), 
						text, 
						null);
				dtde.dropComplete(true);
			}
			catch (Exception ex)
			{
				dtde.dropComplete(false);
			}
		}
	}

	public void dropActionChanged(DropTargetDragEvent dtde) {
	}

}
