package viptool.impl.text.io;

import javax.swing.Icon;

import viptool.base.IWorkbench;
import viptool.base.error.FileInterpreterProviderException;
import viptool.base.io.IFileInterpreter;
import viptool.base.io.IFileInterpreterProvider;
import viptool.base.wizard.IWizard;
import viptool.impl.util.resources.ResourceLoader;
import viptool.project.IAbstractFile;
import viptool.util.resources.ResourceConstants;

/**
 * This is the default file type provider for unknown files. It creates a
 * project element that is a simple text editor.
 */
public class TextFileProvider implements IFileInterpreterProvider
{
    // <><><><><><><><><><><><><><><><><><><><><>
    // Implementation of the FileTypeProvider interface
    // <><><><><><><><><><><><><><><><><><><><><>
    /* @see viptool.util.filetype.FileTypeProvider */
    public IFileInterpreter createFromFile(IAbstractFile file)
            throws FileInterpreterProviderException
    {
        return new TextFile(this, file);
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public boolean matchFormat(IAbstractFile file)
            throws FileInterpreterProviderException
    {
        return true;
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public IFileInterpreter createNewFile(IAbstractFile file)
            throws FileInterpreterProviderException
    {
        // TODO: reimplement
        return null;
        // file.createNewFile();
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public String getDescription()
    {
        return "empty file";
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public String getFileType()
    {
        return "all files";
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public Icon getIcon()
    {
        return ResourceLoader.getInstance().getIcon(
                ResourceConstants.ICON_DEFAULT_FILE);
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public IWizard getNewFileWizard()
    {
        return null;
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public boolean hasNewFileWizard()
    {
        return false;
    }

    /* @see viptool.util.filetype.FileTypeProvider */
    public boolean canCreateNewFile(IWorkbench workbench)
    {
        return (workbench.getCurrentWorkspace() != null && workbench
                .getCurrentWorkspace().getProjectIterator().hasNext());
    }
}
