package viptool.job.error;

import viptool.base.error.VipToolException;
import viptool.job.IJob;

public class JobRuntimeException extends VipToolException
{
    private IJob job_;
    
    public JobRuntimeException(IJob job)
    {
        super();
        job_ = job;
    }

    public JobRuntimeException(IJob job, String message, Throwable throwable)
    {
        super(message, throwable);
        job_ = job;
    }

    public JobRuntimeException(IJob job, String message)
    {
        super(message);
        job_ = job;
    }

    public JobRuntimeException(IJob job, Throwable throwable)
    {
        super(throwable);
        job_ = job;
    }

    public IJob getJob()
    {
        return job_;
    }
}
