package viptool.logger.event;

import java.util.EventListener;

import viptool.logger.LogObject;

/**
 * Interface for listeners that wants to be notified if a change in a
 * Logger occurrs. That means, that all adds and removes of LogObjects will be 
 * notified.
 */
public interface ILoggerChangedListener extends EventListener {
	
	 /**
    * Is called when a LogObject was added to the Logger.
    * 
    * @param logObject
    *        the LogObject that was added to the Logger
    */
	public void logObjectAdded (LogObject logObject);
	
	/**
    * Is called when a LogObject was removed from the Logger
    * 
    * @param logObject
    *        the LogObject that was removed from the Logger
    */
	public void logObjectRemoved (LogObject logObject);

}
