package viptool.project.error;

import viptool.base.error.VipToolException;
import viptool.project.IAbstractFile;

public class ChildNotAcceptedException extends VipToolException
{
    private IAbstractFile file_;
    public ChildNotAcceptedException(IAbstractFile file)
    {
        file_ = file;
    }

    public ChildNotAcceptedException(IAbstractFile file, String message)
    {
        super(message);
        file_ = file;
    }

    public ChildNotAcceptedException(IAbstractFile file, Throwable throwable)
    {
        super(throwable);
        file_ = file;
    }

    public ChildNotAcceptedException(IAbstractFile file, String message, Throwable throwable)
    {
        super(message, throwable);
        file_ = file;
    }
    
    public IAbstractFile getChild()
    {
        return file_;
    }

}
