package viptool.project.event;

import viptool.project.IAbstractFile;

/**
 * This interface is for listeners that want to benotified if files were 
 * removed or added to an abstract folder.
 */
public interface IAbstractFolderListener
{
    /**
     * Called when a file was added to the abstract folder.
     * 
     * @param file
     *            the file that was added to the folder
     */
    public void fileAdded(IAbstractFile file);

    /**
     * Called when a file was removed from the abstract folder.
     * 
     * @param file
     *            the file that was removed from the folder
     */
    public void fileRemoved(IAbstractFile file);
}
