package viptool.project.event;

/**
 * A workspace listener is notified by the workspace if projects were added to or
 * removed from the workspace.
 */
public interface IWorkspaceListener
{
    /**
     * Called if a project was added to the listener. The given event object stores
     * all informations about the project.
     * 
     * @param event
     *            the event object with additional information
     */
    public void projectAdded(WorkspaceEvent event);

    /**
     * Called if a project was removed form the listener. The given event object
     * stores all information about the project.
     * 
     * @param event
     *            the event object with additional information
     */
    public void projectRemoved(WorkspaceEvent event);
}
