package viptool.project.event;

import java.util.EventObject;

import viptool.project.IProject;
import viptool.project.IWorkspace;

/**
 * This event is used by the workspace listener and is used to indicate a change
 * in the workspace, this is when a project is added or removed.
 */
public class WorkspaceEvent extends EventObject
{
    // the project that was added or removed
    private IProject project_;

    // <><><><><><><><><><><><><><><><><><><><><>
    // Constructors
    // <><><><><><><><><><><><><><><><><><><><><>
    /**
     * Constructs a new workspace file event object and initializes it.
     * 
     * @param workspace
     *            the workspace in which the event occurs
     * @param project
     *            the project that was added or removed
     */
    public WorkspaceEvent(IWorkspace workspace, IProject project)
    {
        super(workspace);

        project_ = project;
    }

    // <><><><><><><><><><><><><><><><><><><><><>
    // getter methods
    // <><><><><><><><><><><><><><><><><><><><><>
    /**
     * Returns the workspace that is involved.
     * 
     * @return the workspace in which the project was added or removed
     */
    public IWorkspace getWorkspace()
    {
        return (IWorkspace)getWorkspace();
    }

    /**
     * Returns the project that was added or removed
     * 
     * @return the project
     */
    public IProject getProject()
    {
        return project_;
    }
}
