package viptool.util;

import java.awt.Font;

import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;

public class ExtendedJTextPane extends JTextPane
  {
    Style objectStyle_;
    
    public ExtendedJTextPane()
      {
        StyledDocument styledDocument;
        
        styledDocument = getStyledDocument();
        objectStyle_ = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);
        objectStyle_ = styledDocument.addStyle("Style", objectStyle_);
      }
    
    public void setFont(Font font)
      {
        if(objectStyle_ == null)
          {
            super.setFont(font);
            return;
          }
        
        StyleConstants.setFontSize(objectStyle_, font.getSize());
        StyleConstants.setFontFamily(objectStyle_, font.getFamily());
        StyleConstants.setBold(objectStyle_, font.isBold());
        StyleConstants.setItalic(objectStyle_, font.isItalic());
      }
    
    public void setText(String text)
      {
        StyledDocument styledDocument = getStyledDocument();
        
        try
          {
            styledDocument.insertString(0, text, styledDocument.getStyle("Style"));
          }
        catch(BadLocationException e)
          {
            e.printStackTrace();
          }
      }
  }
