package viptool.util.resources;

import java.awt.Color;
import java.awt.Font;
import java.awt.SystemColor;
import java.io.File;

import viptool.util.GeneralUtils;
import viptool.util.resources.cursor.CursorConstants;
import viptool.util.resources.icon.IconConstants;
import viptool.util.resources.image.ImageConstants;
import viptool.util.resources.preference.PreferenceConstants;
/**
 * Class is needed to enable resourcename changes easily. All resources should
 * get a public static final String to be called by.<br>
 * It is an interface, because an interface can inherit from multiple interfaces
 */
public interface ResourceConstants extends CursorConstants,
        IconConstants, ImageConstants, 
        PreferenceConstants
{
    // <><><><><><><><><><><><><><><><><><><><><>
    // Colors
    // <><><><><><><><><><><><><><><><><><><><><>
    public static final Color    COLOR_CANNOTPERFORM_ACTION         = Color.RED;

    public static final Color    COLOR_CANPERFORM_ACTION            = new Color(
                                                                            41984);

    public static final Color    COLOR_COMPONENT_MOUSEOVER          = Color.BLUE;

    public static final Color    COLOR_DEFAULT_COMPONENT_FOREGROUND = Color.BLACK;

    public static final Color    COLOR_DEFAULT_NODE_ACTION          = Color.LIGHT_GRAY;

    public static final Color    COLOR_DEFAULT_NODE_FILL            = Color.WHITE;

    public static final Color    COLOR_IN_SELECTION                 = Color.ORANGE;

    public static final Color    COLOR_NODE_POSTSET                 = Color.PINK;

    public static final Color    COLOR_NODE_PREPOSTSET              = new Color(
                                                                            308408);

    public static final Color    COLOR_NODE_PRESET                  = Color.YELLOW;

    public static final Color    COLOR_WARNING_LIGHT                = new Color(
                                                                            255,
                                                                            255,
                                                                            160);

    public static final Color    COLOR_WARNING_DARK                 = new Color(
                                                                            224,
                                                                            219,
                                                                            54);

    public static final Color    COLOR_ERROR_LIGHT                  = new Color(
                                                                            255,
                                                                            147,
                                                                            147);

    public static final Color    COLOR_ERROR_DARK                   = new Color(
                                                                            184,
                                                                            15,
                                                                            15);

    public static final Color    COLOR_CONSOLE_DEBUG                = Color.lightGray;

    public static final Color    COLOR_CONSOLE_INFO                 = new Color(
                                                                            50,
                                                                            200,
                                                                            50);

    public static final Color    COLOR_CONSOLE_WARNING              = Color.orange;

    public static final Color    COLOR_CONSOLE_ERROR                = Color.red;

    public static final Color    COLOR_EDITOR_LOCKED                = new Color(
                                                                            251,
                                                                            189,
                                                                            189);

    public static final Color    COLOR_EDITOR_UNLOCKED              = SystemColor.control;

    // <><><><><><><><><><><><><><><><><><><><><>
    // Fonts
    // <><><><><><><><><><><><><><><><><><><><><>
    public static final Font     FONT_DEFAULT_LABEL                 = new Font(
                                                                            "SansSerif",
                                                                            Font.BOLD,
                                                                            11);

    public static final Font     FONT_DEFAULT_CONSOLE               = new Font(
                                                                            "Monospaced",
                                                                            0,
                                                                            12);

    // <><><><><><><><><><><><><><><><><><><><><>
    // Strings
    // <><><><><><><><><><><><><><><><><><><><><>
    public static final String   GROUP_EDITORS                      = "editors";

    public static final String   GROUP_PROJECTS                     = "projects";

    public static final String   MAINFRAME_TITLE                    = "VipTool";

    public static final String   DEFAULT_LOG_FORMAT                 = "{date:yyyy.MMM.dd HH:mm:ss} {level} {message}";

    // <><><><><><><><><><><><><><><><><><><><><>
    // Integers
    // <><><><><><><><><><><><><><><><><><><><><>

    public static final int      MAX_BACKGROUND_JOBS                = 5;

    public static final int      CONSOLE_DIVIDER_LOCATION           = 290;

    public static final int      PROJECTTREE_DIVIDER_LOCATION       = 200;

    // <><><><><><><><><><><><><><><><><><><><><>
    // hidden files
    // <><><><><><><><><><><><><><><><><><><><><>
    public static final String[] HIDDENFILE_START_WITH              = new String[]
                                                                    { "", "",
            "."                                                    };

    public static final String[] HIDDENFILE_END_WITH                = new String[]
                                                                    { ".prj",
            ".wks", ""                                             };

    public static final int      HIDDENFILE_PROJECTFILE             = 0;

    public static final int      HIDDENFILE_WORKSPACEFILE           = 1;

    // <><><><><><><><><><><><><><><><><><><><><>
    // other
    // <><><><><><><><><><><><><><><><><><><><><>

    public static final String   MANIFEST_EXTENSION_CLASS_KEY       = "Extension-Class";

    // <><><><><><><><><><><><><><><><><><><><><>
    // PATHS
    // <><><><><><><><><><><><><><><><><><><><><>
    public static final String   PATH_DEFAULT_WORKSPACE             = GeneralUtils.getUsersHomeDirectory()
                                                                            + ".viptool"
                                                                            + File.separatorChar;
}
